=== Tests/Functional/CMakeLists.txt ===
############################################################################
 # BornAgain/Tests/Functional/CMakeLists.txt (called from top-level CMakeLists.txt)
############################################################################

include_directories(${CMAKE_SOURCE_DIR}/Tests/Functional/TestMachinery)

add_subdirectory(Consistence)
add_subdirectory(CoreSpecial)
add_subdirectory(LibFit)
add_subdirectory(Fitting)
