=== Tests/Functional/Consistence/CMakeLists.txt ===
include(GoogleTest) # provides gtest_discover_tests

set(test TestCoreConsistence)

file(GLOB source_files *.cpp)

add_executable(${test} ${source_files} ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)
target_compile_definitions(${test} PRIVATE -DBORNAGAIN_PYTHON)

target_include_directories(${test} PUBLIC
    ${BornAgainSim_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/3rdparty/common/gtest/gtest-1.8.0/include)
target_link_libraries(${test} BornAgainTestSimFactory gtest)

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX Functional.Consistence.)
