=== Tests/Functional/CoreSpecial/CMakeLists.txt ===
include(GoogleTest) # provides gtest_discover_tests

set(test TestCoreSpecial)

set(source_files
    FourierTransformationTest.cpp
    CoreIOPathTest.cpp
    )

add_executable(${test} ${source_files} ${CMAKE_SOURCE_DIR}/Tests/GTestWrapper/TestAll.cpp)
target_compile_definitions(${test} PRIVATE -DBORNAGAIN_PYTHON)
target_include_directories(${test}
    PUBLIC
    ${CMAKE_SOURCE_DIR}/Tests/Unit/utilities
    ${CMAKE_SOURCE_DIR}/3rdparty/common/gtest/gtest-1.8.0/include)
target_link_libraries(${test} BornAgainSim gtest)

gtest_discover_tests(${test} DISCOVERY_TIMEOUT 300 TEST_PREFIX "Functional.CoreSpecial.")
