=== debian/changelog ===
bornagain (21.0+ds3-2) unstable; urgency=medium

  * Bug fix: "bornagain executable can't find _libBornAgainGUI.so",
    thanks to Heine Larsen (Closes: #1043337).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 29 Aug 2023 17:55:37 +0200

bornagain (21.0+ds3-1) unstable; urgency=medium

  * New upstream version 21.0+ds3
  * refresh the patch series
  * d/rules: move all the install target into the rules file
  * Bug fix: "please add autopkgtests (to add coverage for
    python3-numpy)", thanks to Sandro Tosi (Closes: #1035141).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 29 Aug 2023 16:27:16 +0200

bornagain (20.2+ds3-2) unstable; urgency=medium

  * Patch to increase error margins for testsuite.
  * Fix Hugo build.

 -- Roland Mas <lolando@debian.org>  Tue, 08 Aug 2023 16:39:53 +0200

bornagain (20.2+ds3-1) unstable; urgency=medium

  * New upstream release.
  * Add myself as uploader.
  * Use newly-packaged libheinz and libformfactor.
  * Use Qt6.
  * Update install paths for *.pc, *.so, *.cmake files.
  * Build HTML docs with Hugo (several patches needed).
  * Update debian/copyright (thanks, Lintian!).
  * Re-enable testsuite (hence the build-dependency on clang-format).
  * Re-enable dh_dwz.

 -- Roland Mas <lolando@debian.org>  Sun, 30 Jul 2023 12:43:39 +0200

bornagain (1.19.0-4) unstable; urgency=medium

  [ Neil Williams ]
  * Update control to add Debian PaN maintainers

  [ Sébastien Delafond ]
  * d/control: use Freexian Packaging Team instead of seb@debian.org in Uploaders

  [ Picca Frédéric-Emmanuel ]
  * d/watch: upstream migrated to gitlab

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 24 Jul 2023 14:57:07 +0200
