=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# deal with profiles
CONFIG_SWITCHES=-DCMAKE_DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH) -DCONFIGURE_MANPAGE=ON -DBORNAGAIN_MPI=ON

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_PYTHON_DOCS=OFF
else
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_PYTHON_DOCS=ON
endif

ifneq ($(filter nopython,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_BINDINGS=OFF
else
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_BINDINGS=ON -DPython_ADDITIONAL_VERSIONS="3.9 3.8"
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

export CMAKE_OPTIONS := \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DWITH_SHARED_LIB=1 \
  -DWITH_STATIC_LIB=0 \
  -DWITH_PKGCONFIG_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
  -DCMAKE_PREFIX_PATH="/usr/share/cmake/heinz;/usr/share/cmake/formfactor" \
  -DCMAKE_LIBRARY_PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/bornagain \
  -DCMAKE_BUILD_TYPE=Release

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS) $(CONFIG_SWITCHES) -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

execute_after_dh_auto_install:
	find debian/tmp -name __pycache__ | xargs -r rm -r

execute_after_dh_auto_build:
	cd hugo && hugo

execute_after_dh_clean:
	rm -rf hugo/public hugo/.hugo_build.lock
	find auto -name *.pyc -delete

execute_before_dh_install:
	# bornagain-doc
	dh_install -p bornagain-doc usr/share/BornAgain/Examples/* usr/share/doc/bornagain/examples/
	dh_install -p bornagain-doc hugo/public/* usr/share/doc/bornagain/html

	#  bornagain
	dh_install -p bornagain usr/bin/bornagain
	dh_install -p bornagain usr/lib/*/bornagain/_libBornAgainGUI.so
	dh_install -p bornagain usr/share/BornAgain/Images/* usr/share/bornagain/images/
	dh_install -p bornagain usr/share/man/

	# python3-bornagain
	dh_install -p python3-bornagain -X_libBornAgainGUI.so usr/lib/*/bornagain/*.so
	dh_install -p python3-bornagain usr/lib/python3/*
